+++
date = '2025-04-16T23:26:33+01:00'
draft = true
title = 'Getting the Canon PIXMA TR4755i to Work on Linux'
tags = ['linux', 'uk']
+++

# Introduction

For those of you who don't know, Student Finance England provide free printers to more or less all disabled students
via their Disabled Students' Allowance (DSA) funding. The printer they provide is a Canon PIXMA TR4755i (or at least,
it was for me).

Printers are known for being rather unreliable pieces of technology, particularly on Linux (although, historically,
I've honestly found printers to work much more reliably and without need for troubleshooting on Linux than Windows).
So I was quite concerned when the government sent me a free printer, that I would not be able to use it. Luckily, after
a few short hours of wrangling things, I managed to get it working via USB (I've not tried network printing, but will
update this post once I do). I wanted to make this post to save people time if you are also a disabled student, or
happen to have this model of printer for another reason.

# Guide

## Install CUPS

Firstly, install CUPS and run the CUPS daemon. The commands for this will depend on your distro and how you are
managing services/daemons, so I will leave this to you to figure out. Your distro's wiki or forums should have info on
how to set up CUPS.

## Install the Canon InkJet Printer Driver for Linux

Then you will need to install the Canon InkJet Printer Driver for Linux. Depending on how this is installed, you will
connect to the printer in two different ways.

### Without a package manager (RPM or DEB)

Canon have Linux driver downloads [here][canon_linux_driver_download]. They provide downloads for systems using .debs
and systems using .rpms.

For setup, you should ideally refer to Canon's own manual, which is provided as a tarball [here][canon_manual].
However, as this is not the most accessible format, I'll provide the current version of instructions here on my blog:

Firstly extract the tarball downloaded from Canon's website, and change directory into the newly expanded directory.

    $ tar xzvf cnijfilter2-versionNumberHere-rpmOrDeb.tar.gz
    $ cd cnijfilter2-versionNumberHere

Canon provide an install shell script which will walk you through setup:

    # ./install.sh

When installation is complete, you should be walked through registering the printer. Afterwards, the printer should be
recognised by CUPS, and you can use any system print dialogues to print to the printer.

### Via the AUR

The AUR provides a `cnijfilter2` package. Installing this package provides the `cnijlgmon3` utility, which you should
run as root:

    # cnijlgmon3

The output should say something like:

    direct cnijbe2://Canon/?port=usb&serial=60-12-81-A7-7D-34 "Canon TR4700 series" "USB Printer #1 with status readback for Canon IJ"
    direct cnijbe2://Canon/?port=usb&serial=60-12-81-A7-7D-34 "Canon TR4700 series FAX" "USB Printer #2 with status readback for Canon IJ"

Copy and paste the URL starting with `cnijbe2://Canon/` into the following shell command:

    # lpadmin -p PrinterNameHere -p /usr/share/cups/model/canontr4700.ppd -v "URLhere" -E

`PrinterNameHere` can be whatever you want; it's just how the printer will be named in any print dialogues.

The `.ppd` file should have been provided by `cnijfilter2`.

Replace `URLhere` with the URL you copied above, from the `cnijlgmon3` output.

Afterwards, this printer should have been added to CUPS, and you can print to the printer using any system print dialogues.

[canon_linux_driver_download]: https://www.canon.co.uk/support/consumer/products/printers/pixma/tr-series/pixma-tr4755i.html?type=drivers&os=all
[canon_manual]: https://www.canon-europe.com/supportproduct/tabcontent/?type=manuals&detailId=tcm:13-1641056&productTcmUri=tcm:13-2320166

